<div class="content d-flex flex-column flex-column-fluid" id="kt_content">
  <!--begin::Subheader-->
  <div class="subheader py-2 py-lg-4 subheader-solid" id="kt_subheader">
    <div
      class="container-fluid d-flex align-items-center justify-content-between flex-wrap flex-sm-nowrap"
    >
      <!--begin::Info-->
      <div class="d-flex align-items-center flex-wrap mr-1">
        <!--begin::Page Heading-->
        <div class="d-flex align-items-baseline mr-5">
          <!--begin::Page Title-->
          <h5 class="text-dark font-weight-bold my-2 mr-5">Mémoire</h5>
          <div
            class="subheader-separator subheader-separator-ver mt-2 mb-2 mr-5 bg-gray-200"
          >
            {{ data.length }}
          </div>
          <div class="d-flex align-items-center" id="kt_subheader_search">
            <span class="text-dark-50 font-weight-bold" id="kt_subheader_total"
              >total</span
            >
          </div>
          <!--end::Page Title-->
          <!--begin::Breadcrumb-->
          <!--end::Breadcrumb-->
        </div>
        <!--end::Info-->
        <!--end::Page Heading-->
      </div>
      <!--begin::Toolbar-->
      <div class="d-flex align-items-center">
        <!--begin::Actions-->
        <button class="btn btn-sm btn-primary" (click)="openAddModal(content)">
          Nouveau
        </button>

        <!--end::Actions-->
        <!--begin::Dropdown-->
        <!--end::Dropdown-->
      </div>
      <!--end::Toolbar-->
    </div>
  </div>
  <!--end::Subheader-->
  <!--begin::Entry-->
  <div class="d-flex flex-column-fluid">
    <!--begin::Container-->
    <div class="container">
      <div class="card card-custom" [ngClass]="cssClasses">
        <!-- Header -->
        <div class="card-header bg-gray-200 p-4 border-0 pt-5">
          <h3 class="card-title align-items-start flex-column">
            <select
              name="filter"
              class="form-control"
              id="filter"
              (change)="filtter($event)"
            >
              <option value="" disabled selected>Filtrer</option>
              <option value="false">Actif</option>
              <option value="true">Inactif</option>
            </select>
          </h3>
          <div class="card-toolbar">
            <ul class="nav nav-pills ml-4 nav-pills-sm nav-dark-75">
              <li class="nav-item">
                <form>
                  <div class="form-group form-inline">
                    <input
                      class="form-control form-control-sm"
                      placeholder="Rechercher...."
                      type="text"
                      [(ngModel)]="searchText"
                      name="searchText"
                      (keyup)="search()"
                    />
                  </div>
                </form>
              </li>
              <li class="nav-item">
                <ng-select
                  class="flex-column"
                  name="school"
                  placeholder="filtrer par ecole"
                  [items]="schoolItems"
                  [(ngModel)]="selectedSchool"
                  (ngModelChange)="filterBySchool($event)"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </li>
              <li class="nav-item">
                <ng-select
                  class="flex-column"
                  name="domain"
                  placeholder="filtrer par domaine"
                  [items]="domainItems"
                  [(ngModel)]="selectedDomain"
                  (ngModelChange)="filterByDomain($event)"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </li>
            </ul>
          </div>
        </div>
        <!-- Body -->
        <div class="card-body pt-3 pb-0">
          <!--begin::Table-->
          <div class="table-responsive">
            <table
              class="table table-separate datatable table-head-custom table-vertical-center"
              id="kt_datatable"
            >
              <thead>
                <tr>
                  <th scope="col">N°</th>
                  <th scope="col">Fichier</th>
                  <th scope="col">Sujet</th>
                  <th scope="col">Auteur</th>
                  <th scope="col">Domaine</th>
                  <th scope="col">Ecole</th>
                  <th scope="col">Année académique</th>

                  <th class="text-center">Actions</th>
                </tr>
              </thead>
              <tbody>
                <tr
                  *ngFor="
                    let el of data
                      | slice
                        : (page - 1) * pageSize
                        : (page - 1) * pageSize + pageSize;
                    index as i
                  "
                >
                  <td>{{ i + 1 }}</td>
                  <td>
                    <a [href]="el.file">
                      <span class="svg-icon svg-icon-primary svg-icon-2x">
                        <!--begin::Svg Icon | path:C:\wamp64\www\keenthemes\themes\metronic\theme\html\demo1\dist/../src/media/svg/icons\Files\Download.svg--><svg
                          xmlns="http://www.w3.org/2000/svg"
                          xmlns:xlink="http://www.w3.org/1999/xlink"
                          width="24px"
                          height="24px"
                          viewBox="0 0 24 24"
                          version="1.1"
                        >
                          <g
                            stroke="none"
                            stroke-width="1"
                            fill="none"
                            fill-rule="evenodd"
                          >
                            <rect x="0" y="0" width="24" height="24" />
                            <path
                              d="M2,13 C2,12.5 2.5,12 3,12 C3.5,12 4,12.5 4,13 C4,13.3333333 4,15 4,18 C4,19.1045695 4.8954305,20 6,20 L18,20 C19.1045695,20 20,19.1045695 20,18 L20,13 C20,12.4477153 20.4477153,12 21,12 C21.5522847,12 22,12.4477153 22,13 L22,18 C22,20.209139 20.209139,22 18,22 L6,22 C3.790861,22 2,20.209139 2,18 C2,15 2,13.3333333 2,13 Z"
                              fill="#000000"
                              fill-rule="nonzero"
                              opacity="0.3"
                            />
                            <rect
                              fill="#000000"
                              opacity="0.3"
                              transform="translate(12.000000, 8.000000) rotate(-180.000000) translate(-12.000000, -8.000000) "
                              x="11"
                              y="1"
                              width="2"
                              height="14"
                              rx="1"
                            />
                            <path
                              d="M7.70710678,15.7071068 C7.31658249,16.0976311 6.68341751,16.0976311 6.29289322,15.7071068 C5.90236893,15.3165825 5.90236893,14.6834175 6.29289322,14.2928932 L11.2928932,9.29289322 C11.6689749,8.91681153 12.2736364,8.90091039 12.6689647,9.25670585 L17.6689647,13.7567059 C18.0794748,14.1261649 18.1127532,14.7584547 17.7432941,15.1689647 C17.3738351,15.5794748 16.7415453,15.6127532 16.3310353,15.2432941 L12.0362375,11.3779761 L7.70710678,15.7071068 Z"
                              fill="#000000"
                              fill-rule="nonzero"
                              transform="translate(12.000004, 12.499999) rotate(-180.000000) translate(-12.000004, -12.499999) "
                            />
                          </g>
                        </svg>
                        <!--end::Svg Icon--></span
                      >
                    </a>
                  </td>
                  <td>{{ el.subject }}</td>
                  <td>{{ el.author }}</td>
                  <td>{{ el.domain.name }}</td>
                  <td>{{ el.school.name }}</td>
                  <td>{{ el.schoolYear.start }}-{{ el.schoolYear.end }}</td>
                  <td class="text-center pr-0">
                    <button
                      (click)="openEditModal(contentU, el)"
                      class="btn btn-icon btn-clean btn-sm"
                    >
                      <i class="la la-pen"></i>
                    </button>

                    <button
                      (click)="archive(el.id, i)"
                      class="btn btn-icon btn-clean btn-sm"
                    >
                      <i class="la la-trash"></i>
                    </button>
                  </td>
                </tr>
                <tr *ngIf="data.length == 0">
                  <td colspan="6" class="text-center bg-secondary">
                    Aucun élements
                  </td>
                </tr>
              </tbody>
            </table>
            <div class="d-flex justify-content-between p-2">
              <ngb-pagination
                class=""
                [collectionSize]="collectionSize"
                [(page)]="page"
                [maxSize]="5"
                [pageSize]="pageSize"
                [rotate]="true"
                [ellipses]="false"
                [boundaryLinks]="true"
              >
              </ngb-pagination>
              <select
                class="custom-select custom-select-sm float-right"
                style="width: auto"
                [(ngModel)]="pageSize"
              >
                <option selected disabled>Filtrer</option>
                <option [ngValue]="3">3 elements par page</option>
                <option [ngValue]="5">5 elements par par page</option>
                <option [ngValue]="10">10 elements par par page</option>
              </select>
            </div>
          </div>
          <!--end::Table-->
        </div>
        <ng-template #content let-modal>
          <form #newForm="ngForm" (ngSubmit)="create(newForm.value)">
            <div class="modal-header">
              <h4 class="modal-title" id="modal-basic-title">Nouvel ajout</h4>
              <button
                type="button"
                class="close"
                aria-label="Close"
                (click)="modal.dismiss('Cross click')"
              >
                <i class="la la-close font-size-h3"></i>
              </button>
            </div>
            <div class="modal-body">
              <div *ngIf="error" class="alert alert-danger my-1 alert-rounded">
                {{ error }}
                <button
                  type="button"
                  class="close"
                  data-dismiss="alert"
                  aria-label="Close"
                >
                  <span aria-hidden="true">×</span>
                </button>
              </div>
              <div class="form-group">
                <label>File</label>
                <div class="custom-file">
                  <input
                    type="file"
                    (change)="onFilesAdded($event)"
                    accept=".pdf"
                    name="memoryFileName"
                    id="memoryFileName"
                    class="custom-file-input"
                  />
                  <label class="custom-file-label" for="customFile"
                    >Selectionnez un fichier</label
                  >
                </div>
                <div *ngIf="error">
                  {{ err.message }}
                </div>
                <div *ngIf="uploadResponse.status === 'error'">
                  {{ uploadResponse.message }}
                </div>
                <div *ngIf="uploadResponse.status === 'progress'"
                class="progress-bar progress-bar-info progress-bar-striped"
                  role="progressbar"
                  attr.aria-valuenow="{{ progress }}"
                  aria-valuemin="0"
                  aria-valuemax="100"
                  [ngStyle]="{ width: progress + '%' }"
                >
                {{ file.name }}
                  {{ progress }}%

                </div>
                <!-- <div class="col-lg-9 col-xl-6">
                                    <div class="image-input image-input-outline image-input-changed"
                                        id="kt_profile_avatar"
                                        style="background-image: url(assets/media/users/blank.png)">
                                        <div *ngIf="!urls" class="image-input-wrapper"
                                            [style]="'background-image: url(&quot;'+urls+'&quot;);'"></div>
                                        <div *ngIf="urls" class="image-input-wrapper"
                                            [ngStyle]="{'background-image': 'url(' + urls?.result + ')'}"></div>
                                        <label
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="change" data-toggle="tooltip" title=""
                                            data-original-title="Change avatar">
                                            <i class="fa fa-pen icon-sm text-muted"></i>
                                            <input type="file" (change)="onFilesAdded($event)" name="memoryFileName"
                                                id="memoryFileName" accept=".png, .jpg, .jpeg">
                                            <input type="hidden" name="profile_avatar_remove">
                                        </label>
                                        <span (click)="removeFile()"
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="cancel" data-toggle="tooltip" title=""
                                            data-original-title="Cancel avatar">
                                            <i class="ki ki-bold-close icon-xs text-muted"></i>
                                        </span>
                                        <span
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="remove" data-toggle="tooltip" title=""
                                            data-original-title="Remove avatar">
                                            <i class="ki ki-bold-close icon-xs text-muted"></i>
                                        </span>
                                    </div>
                                    <span class="form-text text-muted">Allowed file types: png, jpg, jpeg.</span>
                                </div> -->
              </div>
              <!--Subject-->
              <div class="form-group">
                <label>Sujet</label>
                <input
                  type="text"
                  name="memorySubject"
                  [(ngModel)]="selected_data.subject"
                  class="form-control"
                  maxlength="250"
                  #memorySubject="ngModel"
                />
                <span
                  *ngIf="
                    memorySubject.invalid &&
                    (memorySubject.dirty || memorySubject.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="memorySubject.errors?.required">
                    Le titre du sujet est requis
                  </small>
                  <small *ngIf="memorySubject.errors.maxlength">
                    Pas plus de 250 caractères pour le titre du sujet
                  </small>
                </span>
              </div>
              <!--Author-->
              <div class="form-group">
                <label>Auteur</label>
                <input
                  type="text"
                  name="memoryAuthor"
                  [(ngModel)]="selected_data.author"
                  class="form-control"
                  maxlength="250"
                  #memoryAuthor="ngModel"
                />
                <span
                  *ngIf="
                    memoryAuthor.invalid &&
                    (memoryAuthor.dirty || memoryAuthor.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="memoryAuthor.errors?.required">
                    Le nom de l'auteur est requis
                  </small>
                  <small *ngIf="memoryAuthor.errors.maxlength">
                    Pas plus de 250 caractères pour le nom de l'auteur
                  </small>
                </span>
              </div>
              <!--Domain-->
              <div class="form-group">
                <label>Domaine</label>
                <ng-select
                  name="memoryDomain"
                  placeholder="Select a domain"
                  [items]="domainItems"
                  [(ngModel)]="selectedDomainItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>

              <!--School-->
              <div class="form-group">
                <label>Ecole</label>
                <ng-select
                  name="memorySchool"
                  placeholder="Select a school"
                  [items]="schoolItems"
                  [(ngModel)]="selectedSchoolItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>

              <!--SchoolYear-->
              <div class="form-group">
                <label>Année académique</label>
                <ng-select
                  name="memorySchoolYear"
                  placeholder="Select a school year"
                  [items]="schoolYearitems"
                  [(ngModel)]="selectedSchoolYearItems"
                  bindLabel="academie"
                  bindValue="id"
                >
                </ng-select>
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="btn btn-outline-dark"
                [disabled]="!newForm.form.valid"
                type="submit"
              >
                Sauvegarder
              </button>
            </div>
          </form>
        </ng-template>
        <ng-template #contentU let-modal>
          <form #newForm="ngForm" (ngSubmit)="edit(newForm.value)">
            <div class="modal-header">
              <h4 class="modal-title" id="modal-basic-title">
                Nouvelle modification
              </h4>
              <button
                type="button"
                class="close"
                aria-label="Close"
                (click)="modal.dismiss('Cross click')"
              >
                <i class="la la-close font-size-h3"></i>
              </button>
            </div>
            <div class="modal-body">
              <div *ngIf="error" class="alert alert-danger my-1 alert-rounded">
                {{ error }}
                <button
                  type="button"
                  class="close"
                  data-dismiss="alert"
                  aria-label="Close"
                >
                  <span aria-hidden="true">×</span>
                </button>
              </div>
              <div class="form-group">
                <label>Fichier</label>
                <div class="custom-file">
                  <input
                    type="hidden"
                    name="id"
                    id="id"
                    #id="ngModel"
                    [(ngModel)]="selected_data.id"
                    class="custom-file-input"
                  />
                  <input
                    type="file"
                    accept=".pdf"
                    (change)="onFilesAdded($event)"
                    name="memoryFileName"
                    id="memoryFileName"
                    class="custom-file-input"
                  />
                  <label class="custom-file-label" for="customFile"
                    >Selectionnez un fichier</label
                  >
                </div>
                <div *ngIf="error">
                  {{ err.message }}
                </div>
                <div *ngIf="uploadResponse.status === 'error'">
                  {{ uploadResponse.message }}
                </div>
                <div *ngIf="uploadResponse.status === 'progress'"
                class="progress-bar progress-bar-info progress-bar-striped"
                  role="progressbar"
                  attr.aria-valuenow="{{ progress }}"
                  aria-valuemin="0"
                  aria-valuemax="100"
                  [ngStyle]="{ width: progress + '%' }"
                >
                {{ file.name }}
                  {{ progress }}%

                </div>
                <!-- <div class="col-lg-9 col-xl-6">
                                    <div class="image-input image-input-outline image-input-changed"
                                        id="kt_profile_avatar"
                                        style="background-image: url(assets/media/users/blank.png)">
                                        <div *ngIf="!urls" class="image-input-wrapper"
                                            [style]="'background-image: url(&quot;'+urls+'&quot;);'"></div>
                                        <div *ngIf="urls" class="image-input-wrapper"
                                            [ngStyle]="{'background-image': 'url(' + urls?.result + ')'}"></div>
                                        <label
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="change" data-toggle="tooltip" title=""
                                            data-original-title="Change avatar">
                                            <i class="fa fa-pen icon-sm text-muted"></i>
                                            <input type="file" (change)="onFilesAdded($event)" name="memoryFileName"
                                                id="memoryFileName" accept=".png, .jpg, .jpeg">
                                            <input type="hidden" name="profile_avatar_remove">
                                        </label>
                                        <span (click)="removeFile()"
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="cancel" data-toggle="tooltip" title=""
                                            data-original-title="Cancel avatar">
                                            <i class="ki ki-bold-close icon-xs text-muted"></i>
                                        </span>
                                        <span
                                            class="btn btn-xs btn-icon btn-circle btn-white btn-hover-text-primary btn-shadow"
                                            data-action="remove" data-toggle="tooltip" title=""
                                            data-original-title="Remove avatar">
                                            <i class="ki ki-bold-close icon-xs text-muted"></i>
                                        </span>
                                    </div>
                                    <span class="form-text text-muted">Allowed file types: png, jpg, jpeg.</span>
                                </div> -->
              </div>
              <!--Subject-->
              <div class="form-group">
                <label>Sujet</label>
                <input
                  type="text"
                  name="memorySubject"
                  [(ngModel)]="selected_data.subject"
                  class="form-control"
                  maxlength="250"
                  #memorySubject="ngModel"
                />
                <span
                  *ngIf="
                    memorySubject.invalid &&
                    (memorySubject.dirty || memorySubject.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="memorySubject.errors?.required">
                    Le titre du sujet est requis
                  </small>
                  <small *ngIf="memorySubject.errors.maxlength">
                    Pas plus de 250 caractères pour le titre du sujet
                  </small>
                </span>
              </div>
              <!--Author-->
              <div class="form-group">
                <label>Auteur</label>
                <input
                  type="text"
                  name="memoryAuthor"
                  [(ngModel)]="selected_data.author"
                  class="form-control"
                  maxlength="250"
                  #memoryAuthor="ngModel"
                />
                <span
                  *ngIf="
                    memoryAuthor.invalid &&
                    (memoryAuthor.dirty || memoryAuthor.touched)
                  "
                  class="text-danger"
                >
                  <small *ngIf="memoryAuthor.errors?.required">
                    Le nom de l'auteur est requis.
                  </small>
                  <small *ngIf="memoryAuthor.errors.maxlength">
                    Pas plus de 250 caractères pour le nom de l'auteur.
                  </small>
                </span>
              </div>
              <!--Domain-->
              <div class="form-group">
                <label>Domaine</label>
                <ng-select
                  name="memoryDomain"
                  placeholder="{{this.selectedDomainItems.name}}"
                  [items]="domainItems"
                  [(ngModel)]="selectedDomainItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>

              <!--School-->
              <div class="form-group">
                <label>Ecole </label>
                <ng-select
                  name="memorySchool"
                  placeholder="{{this.selectedSchoolItems.name}}"
                  [items]="schoolItems"
                  [(ngModel)]="selectedSchoolItems"
                  bindLabel="name"
                  bindValue="id"
                >
                </ng-select>
              </div>

              <!--SchoolYear-->
              <div class="form-group">
                <label>Année academique</label>
                <ng-select
                  name="memoryYear"
                  placeholder="{{this.selectedSchoolYearItems.start}}-{{this.selectedSchoolYearItems.end}}"
                  [items]="schoolYearitems"
                  [(ngModel)]="selectedSchoolYearItems"
                  bindLabel="academie"
                  bindValue="id"
                >
                </ng-select>
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="btn btn-outline-dark"
                [disabled]="!newForm.form.valid"
                type="submit"
              >
                Sauvegarder
              </button>
            </div>
          </form>
        </ng-template>
      </div>
    </div>
    <!--end::Container-->
  </div>
  <!--end::Entry-->
</div>
